
.686p
.model flat,stdcall

INCLUDE prot_macro.inc
INCLUDE pe.inc

RvaToOffset PROTO Rva:DWORD, ImageNtHeaders:DWORD
OffsetToRva PROTO Offs:DWORD, ImageNtHeaders:DWORD
IntervalRand PROTO LowValue:DWORD, HighValue:DWORD
ContinueWork PROTO Info:DWORD
Build1Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, JmpAddress:DWORD
Build15Loader PROTO pPEInfo:DWORD, LdrOffset:DWORD, RealLdrAddress:DWORD, RealLdrSize:DWORD, RealLdrDSize:DWORD
EncryptCode PROTO pPEInfo:DWORD, Key:DWORD
EncryptData PROTO pPEInfo:DWORD, Key:DWORD
EncryptRData PROTO pPEInfo:DWORD, Key:DWORD


PEInfo STRUC
	hPEFile				dd ?
	hMappedFile			dd ?
	FileBase			dd ?
	ImageDosHeader		dd ?
	ImageNtHeaders		dd ?
	ImageFileHeader		dd ?
	ImageOptionalHeader	dd ?
	WorkingSection		dd ?
PEInfo ENDS

LoaderInfo STRUC
	pPEInfo				dd ?
	OriginalRelocRVA	dd ?
	CurrentOffset		dd ?
	OriginalITRVA		dd ?
	OriginalETRVA		dd ?
	TextRVA				dd ?
	TextSize			dd ?
	DataRVA				dd ?
	DataSize			dd ?
	RDataRVA			dd ?
	RDataSize			dd ?
	Imports				dd ?
LoaderInfo ENDS

.data
ITOffset		dd 0
OEPRva			dd 0
NextStageRVA	dd 0
NextStageOff	dd 0
RealLdrRVA		dd 0
OldCodeOffs		dd 0
OldCodeSize		dd 0

.code
assume fs:nothing

real_loader_start:
OriginalReloc		dd 0 ; RVA of original (encrypted) relocations [esi+0]
OriginalCode		dd 0 ; RVA of original code (moved by packer) [esi+4]
OriginalCodeSize	dd 0 ; Size of original code [esi+8]
OriginalEP			dd 0 ; RVA of original entry point [esi+0C]
MyImageBase			dd 0 ; current image base [esi+10]
OldImageBase		dd 0 ; preferred image base [esi+14]
Key					dd 4 dup(0) ; key used for decryption [esi+18]
BaseAddress			dd 0 ; used to set up obfuscation [esi+28]
TextRVA				dd 0 ; RVA of .text section [esi+2C]
TextSize			dd 0 ; size of .text section [esi+30]
DataRVA				dd 0 ; RVA of .data section [esi+34]
DataSize			dd 0 ; size of .data section [esi+38]
RDataRVA			dd 0 ; RVA of .rdata section [esi+3C]
RDataSize			dd 0 ; size of .rdata section [esi+40]
OriginalITRVA		dd 0 ; RVA of original import table [esi+44]
OriginalETRVA		dd 0 ; RVA of original export table [esi+48]
apiGetProcAddress	dd 0 ; RVA of GetProcAddress IAT Entry [esi+4C]
apiLoadLibraryA		dd 0 ; RVA of LoadLibraryA IAT Entry [esi+50]
GPBuffer			db 32h dup(0) ; general purpose buffer [esi+54]
size_ldr_data		EQU $ - real_loader_start

	pop esi ;esi = real_loader_start VA, stack - 4
	mov [esi+10h], eax ; store current image base
	
	gen_instr2 mov, eax, [esi+04h]
	gen_instr2 add, eax, [esi+10h] ; eax = OriginalCode VA
	gen_instr2 mov, ebx, [esi+0Ch]
	gen_instr2 add, ebx, [esi+10h] ; ebx = OriginalEP VA
	gen_instr2 mov, [esi+0Ch], ebx ; save OEP V
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet - real_loader_start
	seh_call call_handler, build_code_key, esi, ebx
	
nextRet:
; restore original code
	pop ebx
	gen_instr2 mov, ecx, [esi+08h]
	gen_instr2 push, esi
	gen_instr2 mov, esi, eax
	gen_instr2 mov, edi, ebx
	gen_instr2 rep, movsb
	gen_instr2 pop, esi
	
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+2Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+30h]
	gen_instr2 call, seh_decrypt ; decrypt .text section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet2 - real_loader_start
	seh_call call_handler, build_data_key, esi, ebx
	
nextRet2:
	pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+34h]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+38h]
	gen_instr2 call, seh_decrypt ; decrypt .data section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet3 - real_loader_start
	seh_call call_handler, build_rdata_key, esi, ebx
	
nextRet3:
	pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+3Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+40h]
	gen_instr2 call, seh_decrypt ; decrypt .rdata section
	gen_instr2 pop, esi
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet5 - real_loader_start
	seh_call call_handler, build_rdata_key2, esi, ebx
	
nextRet5:
	pop ebx
	gen_instr2 push, esi
	gen_instr2 mov, ebp, esi
	gen_instr2 mov, esi, [ebp+3Ch]
	gen_instr2 add, esi, [ebp+10h]
	gen_instr2 mov, ecx, [ebp+40h]
	gen_instr2 call, seh_decrypt ; decrypt .rdata section
	gen_instr2 pop, esi
	
	gen_instr2 call, handle_reloc ; handle relocations
	
	gen_instr2 push, ebx
	gen_instr2 mov, ebx, esi
	gen_instr2 add, ebx, nextRet4 - real_loader_start
	seh_call call_handler, handle_it, esi, ebx
	
nextRet4:
	gen_instr2 pop ebx
	gen_instr2 mov, eax, [esi+0Ch]
	gen_instr2 mov, [esp+24h], eax ; eax = OEP
	popad
	popfd ; return address now on top of the stack
	ret ; jmp to OEP
	
handler:
	mov ecx, [esp+0Ch]
	gen_instr2 mov, dword ptr [ecx+04h], 0
	gen_instr2 mov, dword ptr [ecx+08h], 0
	gen_instr2 mov, dword ptr [ecx+0Ch], 0
	gen_instr2 mov, dword ptr [ecx+10h], 0
	gen_instr2 mov, dword ptr [ecx+14h], 0
	gen_instr2 mov, dword ptr [ecx+18h], 155h
	gen_instr2 mov, ebx, [ecx+0A4h]
	gen_instr2 push, ecx
	gen_instr2 push, ebx
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 pop, ebx
	gen_instr2 pop, ecx
	gen_instr2 sub, eax, ebx
	gen_instr2 cmp, eax, 10000000h
	gen_instr2 ja, crash_it
	gen_instr2 mov, eax, dword ptr [ecx+0B4h]
	gen_instr2 add, eax, do_decrypt - real_loader_start
	gen_instr2 mov, dword ptr [ecx+0B8h], eax
	xor eax, eax
	ret
	
call_handler:
	gen_instr2 mov, ecx, [esp+0Ch]
	gen_instr2 mov, dword ptr [ecx+04h], 0
	gen_instr2 mov, dword ptr [ecx+08h], 0
	gen_instr2 mov, dword ptr [ecx+0Ch], 0
	gen_instr2 mov, dword ptr [ecx+10h], 0
	gen_instr2 mov, dword ptr [ecx+14h], 0
	gen_instr2 mov, dword ptr [ecx+18h], 155h
	gen_instr2 mov, ebx, [ecx+0A4h]
	gen_instr2 push, ecx
	gen_instr2 push, ebx
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 pop, ebx
	gen_instr2 pop, ecx
	gen_instr2 sub, eax, ebx
	gen_instr2 cmp, eax, 10000000h
	gen_instr2 ja, crash_it
	gen_instr2 mov, eax, dword ptr [ecx+09Ch]
	gen_instr2 mov, dword ptr [ecx+0B8h], eax
	xor eax, eax
	ret
	
crash_it:
	push ecx
	push eax
	cpuid
	rdtsc
	pop eax
	pop ecx
	
	mov dword ptr [ecx+0B8h], eax
	xor eax, eax
	ret
	
seh_decrypt:
	gen_instr2 pushad
	gen_instr2 mov, eax, ebp
	gen_instr2 add, eax, handler - real_loader_start
	gen_instr2 push, eax
	gen_instr2 push, fs:[0]
	gen_instr2 mov, fs:[0], esp
	gen_instr2 cpuid
	gen_instr2 rdtsc
	gen_instr2 mov, ebx,eax
	gen_instr2 xor, eax,eax
	gen_instr2 idiv, eax
	ret
	
build_code_key:
	seh_called
	
	setup_obfuscation build_code_key
	
	gen_instr push, esi, , build_code_key
	gen_instr push, edi, , build_code_key
	gen_instr push, ebx, , build_code_key
	gen_instr push, eax, , build_code_key
	
	gen_instr mov, edi, [esi+10h], build_code_key ; edi = image base
	gen_instr mov, eax, edi, build_code_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_code_key ; eax = PE Header
	gen_instr push, eax, , build_code_key
	gen_instr mov, edi, eax, build_code_key
	gen_instr mov, ebx, [edi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.NumberOfRvaAndSizes], build_code_key
	gen_instr mov, [esi+1Ch], ebx, build_code_key
	gen_instr movzx, ebx, [eax.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_code_key
	gen_instr add, edi, ebx, build_code_key
	gen_instr mov, eax, edi, build_code_key
	gen_instr add, eax, 18h, build_code_key
	gen_instr mov, edi, eax, build_code_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_code_key
	gen_instr mov, [esi+18h], eax, build_code_key
	gen_instr pop, edi, , build_code_key
	gen_instr mov, ebx, [esi+0Ch], build_code_key
	gen_instr mov, eax, [ebx], build_code_key
	gen_instr mov, [esi+20h], eax, build_code_key
	gen_instr mov, eax, [ebx+4], build_code_key
	gen_instr mov, [esi+24h], eax, build_code_key
	
	gen_instr pop, eax, , build_code_key
	gen_instr pop, ebx, , build_code_key
	gen_instr pop, edi, , build_code_key
	gen_instr pop, esi, , build_code_key
	ret
	
do_decrypt:
	pop fs:[0]
	add esp, 4
	popad
	jmp decrypt_section
	
build_data_key:
	seh_called
	
	setup_obfuscation build_data_key
	
	gen_instr push, esi, , build_data_key
	gen_instr push, edi, , build_data_key
	
	gen_instr mov, edi, [esi+10h], build_data_key
	gen_instr mov, eax, edi, build_data_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_data_key
	gen_instr mov, edi, eax, build_data_key
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_data_key
	gen_instr add, edi, ebx, build_data_key
	gen_instr mov, eax, edi, build_data_key
	gen_instr add, eax, 18h, build_data_key
	gen_instr mov, edi, eax, build_data_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_data_key
	gen_instr mov, [esi+18h], eax, build_data_key ; key[0] = g_dwNewRawSize
	
	gen_instr mov, eax, esi, build_data_key
	gen_instr add, eax, size_ldr_data, build_data_key
	gen_instr push, [eax], , build_data_key
	gen_instr pop, [esi+1Ch], , build_data_key
	gen_instr add, eax, 4, build_data_key
	gen_instr push, [eax], , build_data_key
	gen_instr pop, [esi+20h], , build_data_key
	gen_instr add, eax, 4, build_data_key
	gen_instr mov, ebx, [eax], build_data_key
	gen_instr push, ebx, , build_data_key
	gen_instr pop, [esi+24h], , build_data_key
	
	gen_instr pop,edi, , build_data_key
	gen_instr pop,esi, , build_data_key
	ret
	
build_rdata_key:
	seh_called
	setup_obfuscation build_rdata_key
	
	gen_instr push, esi, , build_rdata_key
	gen_instr push, edi, , build_rdata_key
	
	gen_instr mov, edi, [esi+10h], build_rdata_key
	gen_instr mov, eax, edi, build_rdata_key
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_rdata_key
	gen_instr mov, edi, eax, build_rdata_key
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_rdata_key
	gen_instr add, edi, ebx, build_rdata_key
	gen_instr mov, eax, edi, build_rdata_key
	gen_instr add, eax, 18h, build_rdata_key
	gen_instr mov, edi, eax, build_rdata_key
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_rdata_key
	gen_instr mov, [esi+18h], eax, build_rdata_key
	
	gen_instr mov, eax, esi, build_rdata_key
	gen_instr add, eax, build_code_key - real_loader_start, build_rdata_key
	gen_instr sub, eax, 12, build_rdata_key
	gen_instr push, [eax], , build_rdata_key
	gen_instr pop, [esi+1Ch], , build_rdata_key
	gen_instr add, eax, 4, build_rdata_key
	gen_instr push, [eax], , build_rdata_key
	gen_instr pop, [esi+20h], , build_rdata_key
	gen_instr add, eax, 4, build_rdata_key
	gen_instr mov, ebx, [eax], build_rdata_key
	gen_instr push, ebx, , build_rdata_key
	gen_instr pop, [esi+24h], , build_rdata_key
	
	gen_instr pop, edi, , build_rdata_key
	gen_instr pop, esi, , build_rdata_key
	ret

build_rdata_key2:
	seh_called
	
	setup_obfuscation build_rdata_key2
	
	gen_instr push, esi, , build_rdata_key2
	gen_instr push, edi, , build_rdata_key2
	
	gen_instr mov, edi, [esi+10h], build_rdata_key2
	gen_instr mov, eax, edi, build_rdata_key2
	gen_instr add, eax, [edi.IMAGE_DOS_HEADER.e_lfanew], build_rdata_key2
	gen_instr mov, edi, eax, build_rdata_key2
	gen_instr movzx, ebx, [edi.IMAGE_NT_HEADERS.FileHeader.IMAGE_FILE_HEADER.SizeOfOptionalHeader], build_rdata_key2
	gen_instr add, edi, ebx, build_rdata_key2
	gen_instr mov, eax, edi, build_rdata_key2
	gen_instr add, eax, 18h, build_rdata_key2
	gen_instr mov, edi, eax, build_rdata_key2
	gen_instr mov, eax, [edi.IMAGE_SECTION_HEADER.SizeOfRawData], build_rdata_key2
	gen_instr mov, [esi+18h], eax, build_rdata_key2
	
	gen_instr mov, eax, esi, build_rdata_key2
	gen_instr add, eax, seh_decrypt - real_loader_start, build_rdata_key2
	gen_instr add, eax, build_code_key - seh_decrypt, build_rdata_key2
	gen_instr sub, eax, 12, build_rdata_key2
	gen_instr push, [eax], , build_rdata_key2
	gen_instr pop, [esi+1Ch], , build_rdata_key2
	gen_instr add, eax, 4, build_rdata_key2
	gen_instr push, [eax], , build_rdata_key2
	gen_instr pop, [esi+20h], , build_rdata_key2
	gen_instr add, eax, 4, build_rdata_key2
	gen_instr mov, ebx, [eax], build_rdata_key2
	gen_instr push, ebx, , build_rdata_key2
	gen_instr pop, [esi+24h], , build_rdata_key2
	
	gen_instr pop, edi, , build_rdata_key2
	gen_instr pop, esi, , build_rdata_key2
	ret
	
; decrypt_section
; decrypts a section of the PE Header
; Params:
; esi = section to decrypt
; ecx = length of section
; ebp = pointer to loader data
decrypt_section:

loop1:
	mov eax, [esi]			; eax -> y
	mov ebx, [esi+4]		; ebx -> z
	
	push esi
	push ecx
	
	test eax, eax
	jnz continue
	test ebx, ebx
	jnz continue
	jmp next1
	
continue:
	mov	ecx, 20h			; ecx -> n
	mov	edx, 0C6EF3720h		; edx -> sum
	
destart:
	mov	esi, eax
	mov	edi, esi

	shl	esi, 4				; y << 4
	shr	edi, 5				; y >> 5
	xor	edi, esi			; y << 4 ^ y >> 5
	add	edi, eax			; (y << 4 ^ y >> 5) + y

	mov	esi, edx
	shr	esi, 11				; sum >> 11
	and	esi, 3				; sum >> 11 & 3
	add ebp, 18h
	mov	esi, [ebp+esi*4]	; k[sum >> 11 & 3]
	sub ebp, 18h
	add	esi, edx			; sum + k[sum >> 11 & 3]
	xor	esi, edi			; (y << 4 ^ y >> 5) + y ^ sum + k[sum >> 11 & 3]
	sub	ebx, esi			; z -= (y << 4 ^ y >> 5) + y ^ sum + k[sum >> 11 & 3]

	sub	edx, 09E3779B9h		; sum -= delta

	mov	esi, ebx
	mov	edi, esi

	shl	esi, 4				; z << 4
	shr	edi, 5				; z >> 5
	xor	edi, esi			; z << 4 ^ z >> 5
	add	edi, ebx			; (z << 4 ^ z >> 5) + z

	mov	esi, edx
	and	esi, 3				; sum & 3
	add ebp, 18h
	mov	esi, [ebp+esi*4]		; k[sum & 3]
	sub ebp, 18h
	add	esi, edx			; sum + k[sum & 3]
	xor	esi, edi			; (z << 4 ^ z >> 5) + z ^ sum + k[sum & 3]
	sub	eax, esi			; y -= (z << 4 ^ z >> 5) + z ^ sum + k[sum & 3]
	
	dec ecx
	test ecx, ecx
	jnz destart
	
	pop ecx
	pop esi
	mov	[esi], eax
	mov	[esi+4], ebx
	jmp skip_pop
	
next1:
	pop ecx
	pop esi
	
skip_pop:
	add esi, 8
	sub ecx,8
	test ecx, ecx
	jnz loop1
	
	ret
	
; handle_reloc
; Params:
; esi: address of parameters
handle_reloc:
	push esi
	push ebp
	
	mov ebp, esi
	
	mov eax, [esi+10h] ; current image base
	mov ebx, [esi+14h] ; preferred image base
	cmp eax, ebx ; do we need to relocate?
	jz no_reloc
	
	sub eax, ebx
	mov edx, eax ; edx = delta
	push edx
	
	mov edi, [esi+10h] ; edi = IMAGE_DOS_HEADER = FileBase
	
	push esi
	mov esi, edi
	add esi, [edi.IMAGE_DOS_HEADER.e_lfanew] ; esi = IMAGE_NT_HEADERS = PE Header
	mov eax, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.LoaderFlags]
	mov edx, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.NumberOfRvaAndSizes]
	pop esi
	
	mov edi, [esi]
	add edi, [esi+10h]
	push edi
@@:
	mov ebx, [edi]
	test ebx, ebx
	jz @f
	xor ebx, edx
	xor ebx, eax
	mov [edi], ebx
	add edi, 4
	jmp @b
@@: ; relocs decrypted, apply them
	pop edi
	pop edx ; edx = delta
	
	push esi
loop2:
	mov esi, [edi.IMAGE_BASE_RELOCATION.VirtualAddress]
	mov eax, [edi.IMAGE_BASE_RELOCATION.SizeOfBlock]
	sub eax, 8
	shr eax, 1
	mov ecx, eax ; ecx = number of relocs
	add edi, 8
	
loop3:
	movzx eax, word ptr [edi]
	mov ebx, eax
	shr eax, 12
	test eax, eax
	jz next
	and ebx, 0FFFh
	push esi
	add esi, ebx
	add esi, [ebp+10h] ; esi = reloc VA
	add [esi], edx
	pop esi
	add edi, 2
	dec ecx
	test ecx, ecx
	jnz loop3
	jmp skip_add
	
next:
	add edi, 2
	
skip_add:
	cmp dword ptr [edi], 0
	jnz loop2
	
	pop esi
	
no_reloc:
	pop ebp
	pop esi
	ret
	
handle_it:
	seh_called
	
	push esi
	
	mov edi, [esi+44h]
	add edi, [esi+10h]
	
do_import:
	mov eax, [edi.IMAGE_IMPORT_DESCRIPTOR.Name1]
	test eax, eax
	jz done_it
	add eax, [esi+10h]
	push edi
	mov edi, [esi+50h]
	add edi, [esi+10h]
	push eax
	call dword ptr [edi]
	mov ebp, eax ; ebp = HANDLE to dll
	pop edi
	mov eax, [edi.IMAGE_IMPORT_DESCRIPTOR.OriginalFirstThunk]
	add eax, [esi+10h]
	mov edx, [edi.IMAGE_IMPORT_DESCRIPTOR.FirstThunk]
	add edx, [esi+10h]
do_function:
	mov ebx, [eax]
	test ebx, ebx
	jz next_import
	push ebx
	and ebx, 80000000h
	test ebx, ebx
	jnz ordinal_import
	pop ebx
	add ebx, [esi+10h]
	add ebx, 2
	push edi
	push eax
	push edx
	mov edi, [esi+4Ch]
	add edi, [esi+10h]
	push ebx
	push ebp
	call dword ptr [edi]
	pop edx
	mov [edx], eax
	pop eax
	pop edi
	jmp next_thunk
ordinal_import:
	pop ebx
	sub ebx, 80000000h
	and ebx, 0FFFFh
	push edi
	push eax
	push edx
	mov edi, [esi+4Ch]
	add edi, [esi+10h]
	push ebx
	push ebp
	call dword ptr [edi]
	pop edx
	mov [edx], eax
	pop eax
	pop edi
next_thunk:
	add eax, 4
	add edx, 4
	jmp do_function
next_import:
	add edi, 14h
	jmp do_import
done_it:
	
	pop esi
	ret
	
real_loader_end:
real_loader_size EQU $ - real_loader_start

; fake import table, only GetProcAddress and LoadLibraryA will be used by loader
it_start:
k32_original	dd k32_imports - k32_original
				dd 0
				dd 0
k32_dll			dd k32_name - k32_original
k32_first		dd k32_iat_start - k32_original

u32_original	dd u32_imports - k32_original
				dd 0
				dd 0
u32_dll			dd u32_name - k32_original
u32_first		dd u32_iat_start - k32_original

gdi32_original	dd gdi32_imports - k32_original
				dd 0
				dd 0
gdi32_dll		dd gdi32_name - k32_original
gdi32_first		dd gdi32_iat_start - k32_original

aapi32_original	dd aapi32_imports - k32_original
				dd 0
				dd 0
aapi32_dll		dd aapi32_name - k32_original
aapi32_first	dd aapi32_iat_start - k32_original

null_descr   dd 0
			 dd 0
			 dd 0
			 dd 0
			 dd 0
			 
k32_name	 db 'KERNEL32.dll',0
k32_imports  dd import1 - k32_original
			 dd import2 - k32_original
			 dd import3 - k32_original
			 dd import4 - k32_original
			 dd import5 - k32_original
			 dd import6 - k32_original
			 dd import7 - k32_original
			 dd import8 - k32_original
			 dd import9 - k32_original
			 dd import10 - k32_original
			 dd import11 - k32_original
			 dd import12 - k32_original
			 dd import13 - k32_original
			 dd import14 - k32_original
			 dd import15 - k32_original
			 dd import16 - k32_original
			 dd import17 - k32_original
			 dd 0

u32_name	 db 'USER32.dll',0
u32_imports  dd import18 - k32_original
			 dd import19 - k32_original
			 dd import20 - k32_original
			 dd import21 - k32_original
			 dd import22 - k32_original
			 dd import23 - k32_original
			 dd 0
			 
gdi32_name	db 'GDI32.dll',0
gdi32_imports	dd import24 - k32_original
				dd import25 - k32_original
				dd import26 - k32_original
				dd import27 - k32_original
				dd 0
				
aapi32_name db 'ADVAPI32.dll',0
aapi32_imports	dd import28 - k32_original
				dd import29 - k32_original
				dd import30 - k32_original
				dd 0
								
k32_iat_start:
impGetProcAddress	dd import1 - k32_original
impLoadLibraryA		dd import2 - k32_original
impk32_3			dd import3 - k32_original
impk32_4			dd import4 - k32_original
impk32_5			dd import5 - k32_original
impk32_6			dd import6 - k32_original
impk32_7			dd import7 - k32_original
impk32_8			dd import8 - k32_original
impk32_9			dd import9 - k32_original
impk32_10			dd import10 - k32_original
impk32_11			dd import11 - k32_original
impk32_12			dd import12 - k32_original
impk32_13			dd import13 - k32_original
impk32_14			dd import14 - k32_original
impk32_15			dd import15 - k32_original
impk32_16			dd import16 - k32_original
impk32_17			dd import17 - k32_original
k32_iat_end:

u32_iat_start:
impu32_1			dd import18 - k32_original
impu32_2			dd import19 - k32_original
impu32_3			dd import20 - k32_original
impu32_4			dd import21 - k32_original
impu32_5			dd import22 - k32_original
impu32_6			dd import23 - k32_original
u32_iat_end:

gdi32_iat_start:
impgdi32_1			dd import24 - k32_original
impgdi32_2			dd import25 - k32_original
impgdi32_3			dd import26 - k32_original
impgdi32_4			dd import27 - k32_original
gdi32_iat_end:

aapi32_iat_start:
impaapi32_1			dd import28 - k32_original
impaapi32_2			dd import29 - k32_original
impaapi32_3			dd import30 - k32_original
aapi32_iat_end:

import1	db 0A0h,01h,'GetProcAddress',0
import2	db 52h, 02, 'LoadLibraryA', 0
import3	db 81h,03h,'VirtualAlloc',0
import4 db 83h,03h,'VirtualFree',0
import5 db 1Ch,02h,'HeapSize',0
import6 db 24h,03h,'SetHandleCount',0
import7 db 0B9h,01h,'GetStdHandle',0
import8 db 10h,01h,'GetCommandLineA',0
import9 db 1Ah,02h,'HeapReAlloc',0
import10 db 16h,02h,'HeapFree',0
import11 db 10h,02h,'HeapAlloc',0
import12 db 37h,03h,'SetStdHandle',0
import13 db 33h,01h,'GetConsoleMode',0
import14 db 22h,01h,'GetConsoleCP',0
import15 db 99h,03h,'WriteConsoleA',0
import16 db 0A3h,03h,'WriteConsoleW',0
import17 db 0D7h,02h,'RtlUnwind',0
import18 db 3Ah,01h,'GetMessageA',0
import19 db 00h,02h,'PeekMessageA',0
import20 db 6Dh,01h,'GetWindowInfo',0
import21 db 0Ch,01h,'GetDC',0
import22 db 7Ah,01h,'GetWindowTextW',0
import23 db 0A1h,02h,'ToUnicode',0
import24 db 0Eh,02h,'SelectObject',0
import25 db 08Fh,00h,'DeleteObject',0
import26 db 12h,00h,'BitBlt',0
import27 db 6Ah,01h,'GetDIBits',0
import28 db 0D0h,01h,'RegCreateKeyA',0
import29 db 0F7h,01h,'RegQueryValueExA',0
import30 db 0CBh,01h,'RegCloseKey',0

	align 4
it_end:
			
ContinueWork PROC uses esi edi Info:DWORD
	mov esi, Info
	test esi, esi
	jz @invalid_info
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	mov esi, [edi.PEInfo.ImageNtHeaders]
	mov eax, [esi.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint]
	mov [OEPRva], eax
	mov esi, Info
	
	call BuildNewIT
	call PrepareAndCopyLdrs
	
	mov eax, 1
	jmp @end1
@invalid_info:
	xor eax, eax
@end1:
	ret
ContinueWork ENDP

; BuildNewIT
; Builds the new import table
; Params:
; esi: Pointer to LoaderInfo structure
BuildNewIT:
	mov edi, [esi.LoaderInfo.pPEInfo]
	mov eax, [esi.LoaderInfo.CurrentOffset]
	mov [ITOffset], eax
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	
	;fixup kernel32 imports
	add [k32_original], eax
	add [k32_dll], eax
	add [k32_first], eax
	add [k32_imports], eax
	add [k32_imports+04h], eax
	add [k32_imports+08h], eax
	add [k32_imports+0Ch], eax
	add [k32_imports+10h], eax
	add [k32_imports+14h], eax
	add [k32_imports+18h], eax
	add [k32_imports+1Ch], eax
	add [k32_imports+20h], eax
	add [k32_imports+24h], eax
	add [k32_imports+28h], eax
	add [k32_imports+2Ch], eax
	add [k32_imports+30h], eax
	add [k32_imports+34h], eax
	add [k32_imports+38h], eax
	add [k32_imports+3Ch], eax
	add [k32_imports+40h], eax	
	add [impGetProcAddress], eax
	add [impLoadLibraryA], eax
	add [impk32_3], eax
	add [impk32_4], eax
	add [impk32_5], eax
	add [impk32_6], eax
	add [impk32_7], eax
	add [impk32_8], eax
	add [impk32_9], eax
	add [impk32_10], eax
	add [impk32_11], eax
	add [impk32_12], eax
	add [impk32_13], eax
	add [impk32_14], eax
	add [impk32_15], eax
	add [impk32_16], eax
	add [impk32_17], eax
	
	;fixup user32 import
	add [u32_original], eax
	add [u32_dll], eax
	add [u32_first], eax
	add [u32_imports], eax
	add [u32_imports+4], eax
	add [u32_imports+8], eax
	add [u32_imports+0Ch], eax
	add [u32_imports+10h], eax
	add [u32_imports+14h], eax
	add [impu32_1], eax
	add [impu32_2], eax
	add [impu32_3], eax
	add [impu32_4], eax
	add [impu32_5], eax
	add [impu32_6], eax
	
	;fixup gdi32 import
	add [gdi32_original], eax
	add [gdi32_dll], eax
	add [gdi32_first], eax
	add [gdi32_imports], eax
	add [gdi32_imports+04h], eax
	add [gdi32_imports+08h], eax
	add [gdi32_imports+0Ch], eax
	add [impgdi32_1], eax
	add [impgdi32_2], eax
	add [impgdi32_3], eax
	add [impgdi32_4], eax
	
	;fixup advapi32 import
	add [aapi32_original], eax
	add [aapi32_dll], eax
	add [aapi32_first], eax
	add [aapi32_imports], eax
	add [aapi32_imports+04h], eax
	add [aapi32_imports+08h], eax
	add [impaapi32_1], eax
	add [impaapi32_2], eax
	add [impaapi32_3], eax
	
	mov eax, [ITOffset]
	add eax, [edi.PEInfo.FileBase]
	push edi
	push esi
	xor ecx, ecx
	lea esi, it_start
	mov edi, eax
	mov ecx, it_end - it_start
	rep movsb
	pop esi
	pop edi
	mov eax, [ITOffset]
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	push esi
	mov esi, [edi.PEInfo.ImageNtHeaders]
	mov [esi.IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT*8).VirtualAddress], eax
	mov [esi.IMAGE_NT_HEADERS.OptionalHeader.DataDirectory(IMAGE_DIRECTORY_ENTRY_IMPORT*8).iSize], 64h
	pop esi
	add [esi.LoaderInfo.CurrentOffset], it_end - it_start
	ret
	
PrepareRealLoader:
	push esi
	push edi
	push ebx
	
	mov eax, [esi.LoaderInfo.OriginalRelocRVA]
	mov [OriginalReloc], eax
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, [OldCodeOffs], [edi.PEInfo.ImageNtHeaders]
	mov [OriginalCode], eax
	
	mov eax, [OldCodeSize]
	mov [OriginalCodeSize], eax
		
	mov eax, [OEPRva]
	mov [OriginalEP], eax
	
	mov eax, [edi.PEInfo.ImageNtHeaders]
	mov ebx, [eax.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.ImageBase]
	mov [OldImageBase], ebx
	
	mov eax, [esi.LoaderInfo.TextRVA]
	mov [TextRVA], eax
	
	mov eax, [esi.LoaderInfo.TextSize]
	mov [TextSize], eax
	
	mov eax, [esi.LoaderInfo.DataRVA]
	mov [DataRVA], eax
	
	mov eax, [esi.LoaderInfo.DataSize]
	mov [DataSize], eax
	
	mov eax, [esi.LoaderInfo.RDataRVA]
	mov [RDataRVA], eax
	
	mov eax, [esi.LoaderInfo.RDataSize]
	mov [RDataSize], eax
	
	mov eax, [esi.LoaderInfo.OriginalITRVA]
	mov [OriginalITRVA], eax
	
	mov eax, [esi.LoaderInfo.OriginalETRVA]
	mov [OriginalETRVA], eax
	
	mov eax, [k32_first]
	mov [apiGetProcAddress], eax
	
	add eax, 4
	mov [apiLoadLibraryA], eax
	
	pop ebx
	pop edi
	pop esi
	ret
	
PrepareAndCopyLdrs:
	push ebp
	mov ebp, esp
	sub esp, 10Ch
	
	; [ebp-04] = 1st stage loader size
	
	push esi
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	mov ebx, eax
	add eax, 64h
	invoke IntervalRand, ebx, eax
	mov [NextStageOff], eax
	
	mov [esi.LoaderInfo.CurrentOffset], eax
	
	mov edi, [esi.LoaderInfo.pPEInfo]
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [NextStageRVA], eax
	
	; builds first stage loader in memory
	lea ebx, [ebp-10Ch]
	invoke Build1Loader, edi, ebx, [NextStageRVA]
	mov [ebp-04], eax
	
	; the 1st stage loader has been built, now the .text section gets encrypted, before moving the ep
	lea eax, [ebp-10Ch]
	invoke EncryptCode, edi, eax
	
	lea eax, real_loader_start
	add eax, size_ldr_data
	invoke EncryptData, edi, eax
	
	;two-pass encryption of the .rdata section
	;1st pass: encrypt using the last 12 bytes of the loader, no bp this way
	lea eax, real_loader_start
	add eax, build_code_key - real_loader_start
	sub eax, 12
	invoke EncryptRData, edi, eax
	
	;2nd pass: encrypt using the last 12 bytes of seh_decrypt
	lea eax, seh_decrypt
	add eax, build_code_key - seh_decrypt
	sub eax, 12
	invoke EncryptRData, edi, eax
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	add eax, 64h ; we store the original ep 100 bytes away from 2nd stage loader
	mov [OldCodeOffs], eax
	
	mov ebx, [edi.PEInfo.ImageNtHeaders]
	
	; this moves the original entry point of the dll
	push esi
	push edi
	push eax
	invoke RvaToOffset, [ebx.IMAGE_NT_HEADERS.OptionalHeader.IMAGE_OPTIONAL_HEADER.AddressOfEntryPoint], [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	mov esi, eax
	pop eax
	add eax, [edi.PEInfo.FileBase]
	mov edi, eax
	mov ecx, [ebp-04]
	rep movsb
	pop edi
	pop esi
	
	; copy the first stage loader
	mov eax, [OEPRva]
	invoke RvaToOffset, eax, [edi.PEInfo.ImageNtHeaders]
	add eax, [edi.PEInfo.FileBase]
	push esi
	push edi
	lea esi, [ebp-10Ch]
	mov edi, eax
	mov ecx, [ebp-04]
	rep movsb
	pop edi
	pop esi
	
	add [esi.LoaderInfo.CurrentOffset], 64h
	mov eax, [ebp-04]
	add [esi.LoaderInfo.CurrentOffset], eax
	mov [OldCodeSize], eax
	
	add [esi.LoaderInfo.CurrentOffset], real_loader_size
	
	; fills the data section of the real loader
	call PrepareRealLoader
	
	; copy the real loader
	lea eax, real_loader_start
	mov ebx, [esi.LoaderInfo.CurrentOffset]
	sub ebx, real_loader_size
	add ebx, [edi.PEInfo.FileBase]
	push esi
	push edi
	mov esi, eax
	mov edi, ebx
	mov ecx, real_loader_end - real_loader_start
	rep movsb
	pop edi
	pop esi
	
	mov eax, [esi.LoaderInfo.CurrentOffset]
	sub eax, real_loader_size
	invoke OffsetToRva, eax, [edi.PEInfo.ImageNtHeaders]
	mov [RealLdrRVA], eax
	
	mov eax, size_ldr_data
	push eax
	mov eax, real_loader_size
	push eax
	push dword ptr [RealLdrRVA]
	mov eax, [NextStageOff]
	inc eax ; since the first instruction was generated by stage 1 loader, we skip it
	add eax, [edi.PEInfo.FileBase]
	push eax
	push [esi.LoaderInfo.pPEInfo]
	call Build15Loader
	
	pop esi
	mov esp, ebp
	pop ebp
	ret	
END